#!/usr/bin/env python
# extract and rename KA videos
# Mark Feineigle 2015/06/28, 2015/12/15, 2015/12/21
#USAGE
# set page
# should work in one run, only need to number the new folder it makes

#TODO untested, leading 0 in filename, test with 10+ videos
# numbers folders as you make them (len(walk)+1)
#   only works when numbering from 1

# NOTE 9885 items in /home/egg/archive/video/khan_academy/ka-lite-videos
# TODO
# extract all at once? no real need, as you go
from urllib import urlopen
from re import DOTALL, findall
from os import makedirs, walk
from shutil import copy
#SET PAGE to scan
PAGE="/math/trigonometry/polynomial_and_rational/polynomial_tutorial/"
#TODO Test full page var, can use CLI and argparse/argv

pagefolder = PAGE.split("/")[-2] #last folder in page
pageroot = "/".join(PAGE.split("/")[:-2]) #the path to folder above the page
#Original video path
origVidPath = "/home/egg/archive/video/khan_academy/ka-lite-videos/"
try: #how many folders are in the destination directory (for numbering)
  folderNum = len([i for i in walk(origVidPath+"sorted/"+pageroot)][0][1])+1
except: folderNum = 1
if len(str(folderNum)) < 2: #add a leading 0 if needed
  folderNum = "0"+str(folderNum)
try: #make the destination directory (full path) for a new category
  makedirs(origVidPath+"sorted/"+pageroot+"/"+str(folderNum)+"_"+pagefolder)
except Exception, e: print str(e)
#destination path
destPath = origVidPath+"sorted/"+pageroot+"/"+str(folderNum)+"_"+pagefolder+"/"
#Extract video and title
html = urlopen("http://127.0.0.1:8008/"+PAGE).read() #open starting PAGE
#NOTE? #html = urlopen(PAGE).read() #open starting PAGE
#find video title [list]  and  #find local video id [list]
videotitles = findall('video-available">\n(.*?)</a>', html, DOTALL)
videoids = findall('data-video-id="(.*?)"></span>', html)
videotitles = [i.strip() for i in videotitles] #cleanup whitespace
#copy and print results
x = 0 #counter
while x*2 < len(videotitles):
  print videotitles[x*2]+"\t:\t"+videoids[x]
  #copies, numbers new videos, x+1 b/c x starts at 0
  #x*2 b/c videotitles repeat, process every other one
  if x < 9: # leading 0 in filename, test with 10+ videos
    copy(origVidPath+videoids[x]+".mp4", destPath+"0"+str(x+1)+"_"
      +videotitles[x*2]+".mp4")
  else:
    copy(origVidPath+videoids[x]+".mp4", destPath+str(x+1)+"_"
      +videotitles[x*2]+".mp4")
  x+=1 #increment counter
